## icinga2 2.4.10

=== CMakeLists.txt ===
# Icinga 2
# Copyright (C) 2012-2016 Icinga Development Team (https://www.icinga.org/)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation
# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.

cmake_minimum_required(VERSION 2.6)
set(BOOST_MIN_VERSION "1.41.0")

project(icinga2)
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/third-party/cmake")

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
endif()

option(ICINGA2_WITH_MYSQL "Build the MySQL IDO module" ON)
option(ICINGA2_WITH_PGSQL "Build the PostgreSQL IDO module" ON)
option(ICINGA2_WITH_CHECKER "Build the checker module" ON)
option(ICINGA2_WITH_COMPAT "Build the compat module" ON)
option(ICINGA2_WITH_DEMO "Build the demo module" OFF)
option(ICINGA2_WITH_HELLO "Build the hello module" OFF)
option(ICINGA2_WITH_LIVESTATUS "Build the Livestatus module" ON)
option(ICINGA2_WITH_NOTIFICATION "Build the notification module" ON)
option(ICINGA2_WITH_PERFDATA "Build the perfdata module" ON)
option(ICINGA2_WITH_STUDIO "Build the Icinga Studio application" OFF)
option(ICINGA2_WITH_TESTS "Run unit tests" ON)

file(STRINGS icinga2.spec VERSION_LINE REGEX "^Version: ")
string(REPLACE "Version: " "" ICINGA2_VERSION ${VERSION_LINE})

include(GNUInstallDirs)
include(InstallConfig)

set(ICINGA2_USER "icinga" CACHE STRING "Icinga 2 user")
set(ICINGA2_GROUP "icinga" CACHE STRING "Icinga 2 group")
set(ICINGA2_COMMAND_GROUP "icingacmd" CACHE STRING "Icinga 2 command group")
set(ICINGA2_RUNDIR "${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/run" CACHE STRING "/run directory")
set(ICINGA2_PLUGINDIR "/usr/lib/nagios/plugins" CACHE STRING "Path for the check plugins")
set(ICINGA2_GIT_VERSION_INFO ON CACHE BOOL "Whether to use git describe")
set(ICINGA2_UNITY_BUILD ON CACHE BOOL "Whether to perform a unity build")
set(ICINGA2_LTO_BUILD OFF CACHE BOOL "Whether to use LTO")

file(READ "${CMAKE_CURRENT_SOURCE_DIR}/COPYING" ICINGA2_LICENSE_GPL)
file(READ "${CMAKE_CURRENT_SOURCE_DIR}/COPYING.Exceptions" ICINGA2_LICENSE_ADDITIONS)
set(ICINGA2_LICENSE "${ICINGA2_LICENSE_GPL}\n\n---\n\n${ICINGA2_LICENSE_ADDITIONS}")
file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/LICENSE.txt" ${ICINGA2_LICENSE})

include(GetGitRevisionDescription)
git_describe(GIT_VERSION --tags)
if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/icinga-version.h.force)
  configure_file(icinga-version.h.force ${CMAKE_CURRENT_BINARY_DIR}/icinga-version.h COPYONLY)
else()
  if(NOT ICINGA2_GIT_VERSION_INFO OR GIT_VERSION MATCHES "-NOTFOUND$")
    file(STRINGS icinga2.spec SPEC_VERSION REGEX "^Version:")
    string(LENGTH "${SPEC_VERSION}" SPEC_VERSION_LENGTH)
    math(EXPR SPEC_VERSION_LENGTH "${SPEC_VERSION_LENGTH} - 9")
    string(SUBSTRING ${SPEC_VERSION} 9 ${SPEC_VERSION_LENGTH} SPEC_VERSION)

    file(STRINGS icinga2.spec SPEC_REVISION REGEX "^%define revision ")
    string(LENGTH "${SPEC_REVISION}" SPEC_REVISION_LENGTH)
    math(EXPR SPEC_REVISION_LENGTH "${SPEC_REVISION_LENGTH} - 17")
    string(SUBSTRING ${SPEC_REVISION} 17 ${SPEC_REVISION_LENGTH} SPEC_REVISION)

    set(GIT_VERSION "r${SPEC_VERSION}-${SPEC_REVISION}")
  endif()
  configure_file(icinga-version.h.cmake icinga-version.h)
endif()

if(WIN32)
  set(Boost_USE_STATIC_LIBS ON)
  add_definitions(-DBOOST_ALL_NO_LIB)
  add_definitions(/bigobj)
endif()

if(NOT DEFINED LOGROTATE_HAS_SU)
  set(LOGROTATE_HAS_SU OFF)
  execute_process(COMMAND "/usr/sbin/logrotate" ERROR_VARIABLE LOGROTATE_OUTPUT)
  if(LOGROTATE_OUTPUT)
    string(REGEX REPLACE "^logrotate ([0-9.]*).*" "\\1" LOGROTATE_VERSION
      ${LOGROTATE_OUTPUT})
    message(STATUS "Found logrotate (found version \"${LOGROTATE_VERSION}\")")
    if("${LOGROTATE_VERSION}" VERSION_GREATER "3.7.9")
      set(LOGROTATE_HAS_SU ON)
    endif()
  endif()
endif()
if(LOGROTATE_HAS_SU)
  set(LOGROTATE_USE_SU "\n\tsu ${ICINGA2_USER} ${ICINGA2_GROUP}")
endif()

find_package(Boost ${BOOST_MIN_VERSION} COMPONENTS thread system program_options regex REQUIRED)

link_directories(${Boost_LIBRARY_DIRS})
include_directories(${Boost_INCLUDE_DIRS})

find_package(OpenSSL REQUIRED)
include_directories(${OPENSSL_INCLUDE_DIR})

find_package(YAJL)

if(NOT YAJL_FOUND)
  include_directories(${icinga2_BINARY_DIR}/third-party/yajl/include)
  link_directories(${icinga2_BINARY_DIR}/third-party/yajl)
  set(YAJL_LIBRARIES "yajl")
endif()

find_package(Editline)
set(HAVE_EDITLINE "${EDITLINE_FOUND}")

find_package(Termcap)
set(HAVE_TERMCAP "${TERMCAP_FOUND}")

include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/lib
  ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_BINARY_DIR}/lib
)

#set(CMAKE_BUILD_WITH_INSTALL_RPATH TRUE)

if(APPLE)
  set(CMAKE_INSTALL_NAME_DIR "@executable_path/..")
  set(CMAKE_MACOSX_RPATH 0)
endif(APPLE)

if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Qunused-arguments -g")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Qunused-arguments -g")
endif()

if(CMAKE_C_COMPILER_ID STREQUAL "SunPro")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -mt")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mt -library=stlport4")
endif()

if(CMAKE_C_COMPILER_ID STREQUAL "GNU")
  if(CMAKE_SYSTEM_NAME MATCHES AIX)
    set(CMAKE_CXX_FLAGS "${CMAKE_C_FLAGS} -g -lpthread")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -lpthread")
  elseif(CMAKE_SYSTEM_NAME MATCHES "kOpenBSD.*|OpenBSD.*")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -pthread")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -pthread")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -lpthread")
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -lpthread")
  else()
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -pthread")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -pthread")
  endif()

  if(NOT CMAKE_SYSTEM_NAME MATCHES AIX AND NOT CMAKE_SYSTEM_NAME MATCHES OpenBSD AND NOT CMAKE_SYSTEM_NAME MATCHES SunOS)
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--gc-sections -Wl,--no-export-dynamic -Bsymbolic-functions -Wl,--dynamic-list-cpp-typeinfo -Wl,--dynamic-list-data")
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--gc-sections -Wl,--no-export-dynamic -Bsymbolic-functions -Wl,--dynamic-list-cpp-typeinfo -Wl,--dynamic-list-data")
  endif()
endif()

if(ICINGA2_LTO_BUILD)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -flto -fno-fat-lto-objects")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -flto -fno-fat-lto-objects")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -flto")
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -flto")
endif()

include(CheckCCompilerFlag)

check_c_compiler_flag(-fvisibility-inlines-hidden HAVE_VISIBILITY_INLINES_HIDDEN)

if(HAVE_VISIBILITY_INLINES_HIDDEN)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fvisibility-inlines-hidden")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility-inlines-hidden")
endif()

if(MSVC)
  add_definitions(-D_CRT_SECURE_NO_DEPRECATE -D_CRT_NONSTDC_NO_DEPRECATE -D_SCL_SECURE_NO_WARNINGS)
endif()

set(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR}/Bin/${CMAKE_BUILD_TYPE} CACHE PATH "Library output path")
set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR}/Bin/${CMAKE_BUILD_TYPE} CACHE PATH "Executable output path")

include(CheckSymbolExists)
include(CheckFunctionExists)
include(CheckLibraryExists)
include(CheckIncludeFileCXX)

check_symbol_exists(__COUNTER__ "" HAVE_COUNTER_MACRO)

if(NOT HAVE_COUNTER_MACRO AND ICINGA2_UNITY_BUILD)
  message(STATUS "Your C/C++ compiler does not support the __COUNTER__ macro. Disabling unity build.")
  set(ICINGA2_UNITY_BUILD FALSE)
endif()

set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -DI2_DEBUG")
set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -DI2_DEBUG")

check_function_exists(vfork HAVE_VFORK)
check_function_exists(backtrace_symbols HAVE_BACKTRACE_SYMBOLS)
check_function_exists(pipe2 HAVE_PIPE2)
check_function_exists(nice HAVE_NICE)
check_library_exists(dl dladdr "dlfcn.h" HAVE_DLADDR)
check_library_exists(execinfo backtrace_symbols "" HAVE_LIBEXECINFO)
check_include_file_cxx(cxxabi.h HAVE_CXXABI_H)

if(HAVE_LIBEXECINFO)
  set(HAVE_BACKTRACE_SYMBOLS TRUE)
endif()

set(_ICINGA2_CXX11 OFF)

if(UNIX)
  include(CheckCXXCompilerFlag)
  check_cxx_compiler_flag("-std=c++11" CXX_FLAG_CXX11)

  if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    exec_program(${CMAKE_CXX_COMPILER}
      ARGS -dumpversion
      OUTPUT_VARIABLE _ICINGA2_COMPILER_VERSION
    )

    if("${_ICINGA2_COMPILER_VERSION}" VERSION_LESS "4.7.0")
      message(STATUS "Your version of GCC is too old for building Icinga 2 in C++11 mode.")
      set(CXX_FLAG_CXX11 OFF)
    endif()
  endif()

  if(CXX_FLAG_CXX11)
    set(_ICINGA2_CXX11 ON)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
  endif()

  check_cxx_compiler_flag("-Wno-inconsistent-missing-override" CXX_FLAG_NO_OVERRIDE_WARNING)
  if(CXX_FLAG_NO_OVERRIDE_WARNING)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-inconsistent-missing-override")
  endif()
endif()

if(NOT MSVC)
  set(CXX_FEATURE_OVERRIDE OFF)

  if(_ICINGA2_CXX11)
    include(CheckCXXSourceCompiles)
    check_cxx_source_compiles("class Base { public: virtual void test(void) { } }; class Derived : public Base { virtual void test(void) override { } }; int main(){}" CXX_FEATURE_OVERRIDE)
  endif()

  if(NOT CXX_FEATURE_OVERRIDE)
    add_definitions("-Doverride=")
  endif()
endif()

configure_file(config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h ESCAPE_QUOTES)

install(
  FILES README.md COPYING COPYING.Exceptions AUTHORS ChangeLog NEWS
  DESTINATION ${CMAKE_INSTALL_DOCDIR}
)

include(CTest)
enable_testing()

set_property(GLOBAL PROPERTY USE_FOLDERS ON)

add_subdirectory(third-party)
add_subdirectory(tools)
add_subdirectory(lib)
add_subdirectory(icinga-app)
add_subdirectory(etc)
add_subdirectory(itl)
add_subdirectory(doc)
add_subdirectory(agent)
add_subdirectory(plugins)

if(MSVC)
  add_subdirectory(icinga-installer)
endif()

if(ICINGA2_WITH_STUDIO)
  add_subdirectory(icinga-studio)
endif()

if(ICINGA2_WITH_TESTS)
  add_subdirectory(test)
endif()

set(CPACK_PACKAGE_NAME "Icinga 2")
set(CPACK_PACKAGE_VENDOR "Icinga Development Team")
set(CPACK_PACKAGE_VERSION ${ICINGA2_VERSION})
set(CPACK_PACKAGE_INSTALL_DIRECTORY "ICINGA2")
set(CPACK_PACKAGE_ICON "${CMAKE_CURRENT_SOURCE_DIR}/icinga-app\\\\icinga.ico")
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_BINARY_DIR}/LICENSE.txt")

set(CPACK_PACKAGE_EXECUTABLES "Icinga2SetupAgent;Icinga 2 Agent Wizard;icinga-studio;Icinga Studio")
set(CPACK_WIX_PRODUCT_ICON "${CMAKE_CURRENT_SOURCE_DIR}/icinga-app\\\\icinga.ico")
set(CPACK_WIX_UPGRADE_GUID "52F2BEAA-4DF0-4C3E-ABDC-C0F61DE4DF8A")
set(CPACK_WIX_EXTENSIONS "WixUtilExtension")
set(CPACK_WIX_UI_BANNER "${CMAKE_CURRENT_SOURCE_DIR}/icinga-installer/bannrbmp.bmp")
set(CPACK_WIX_UI_DIALOG "${CMAKE_CURRENT_SOURCE_DIR}/icinga-installer/dlgbmp.bmp")
set(CPACK_WIX_PATCH_FILE "${CMAKE_CURRENT_BINARY_DIR}/icinga-installer/icinga2.wixpatch.Debug")
set(CPACK_WIX_PATCH_FILE "${CMAKE_CURRENT_BINARY_DIR}/icinga-installer/icinga2.wixpatch")

set(CMAKE_INSTALL_SYSTEM_RUNTIME_LIBS_SKIP TRUE)
include(InstallRequiredSystemLibraries)

if(WIN32)
  if(CMAKE_VS_PLATFORM_NAME STREQUAL "x64")
    set(NSCP_URL "https://github.com/mickem/nscp/releases/download/0.4.4.19/NSCP-0.4.4.19-x64.msi")

=== etc/CMakeLists.txt ===
# Icinga 2
# Copyright (C) 2012-2016 Icinga Development Team (https://www.icinga.org/)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation
# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.

configure_file(icinga/icinga-classic-apache.conf.cmake ${CMAKE_CURRENT_BINARY_DIR}/icinga/icinga-classic-apache.conf @ONLY)
configure_file(icinga2/init.conf.cmake ${CMAKE_CURRENT_BINARY_DIR}/icinga2/init.conf @ONLY)

if(NOT WIN32)
  configure_file(icinga2/constants.conf.cmake ${CMAKE_CURRENT_BINARY_DIR}/icinga2/constants.conf @ONLY)
endif()

if(${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
  configure_file(logrotate.d/icinga2.cmake ${CMAKE_CURRENT_BINARY_DIR}/logrotate.d/icinga2 @ONLY)
endif()

install_if_not_exists(${CMAKE_CURRENT_BINARY_DIR}/icinga2/init.conf ${CMAKE_INSTALL_SYSCONFDIR}/icinga2)

if(NOT WIN32)
  install_if_not_exists(${CMAKE_CURRENT_BINARY_DIR}/icinga2/constants.conf ${CMAKE_INSTALL_SYSCONFDIR}/icinga2)
	install_if_not_exists(icinga2/icinga2.conf ${CMAKE_INSTALL_SYSCONFDIR}/icinga2)
else()
  install_if_not_exists(${CMAKE_CURRENT_SOURCE_DIR}/icinga2/win32/constants.conf ${CMAKE_INSTALL_SYSCONFDIR}/icinga2)
		install_if_not_exists(icinga2/win32/icinga2.conf ${CMAKE_INSTALL_SYSCONFDIR}/icinga2)
endif()

install_if_not_exists(icinga2/zones.conf ${CMAKE_INSTALL_SYSCONFDIR}/icinga2)
install_if_not_exists(icinga2/conf.d/app.conf ${CMAKE_INSTALL_SYSCONFDIR}/icinga2/conf.d)
install_if_not_exists(icinga2/conf.d/commands.conf ${CMAKE_INSTALL_SYSCONFDIR}/icinga2/conf.d)
install_if_not_exists(icinga2/conf.d/downtimes.conf ${CMAKE_INSTALL_SYSCONFDIR}/icinga2/conf.d)
install_if_not_exists(icinga2/conf.d/groups.conf ${CMAKE_INSTALL_SYSCONFDIR}/icinga2/conf.d)

if(NOT WIN32)
  install_if_not_exists(icinga2/conf.d/hosts.conf ${CMAKE_INSTALL_SYSCONFDIR}/icinga2/conf.d)
	install_if_not_exists(icinga2/conf.d/services.conf ${CMAKE_INSTALL_SYSCONFDIR}/icinga2/conf.d)
else()
  install_if_not_exists(icinga2/conf.d/win32/hosts.conf ${CMAKE_INSTALL_SYSCONFDIR}/icinga2/conf.d)
	install_if_not_exists(icinga2/conf.d/win32/services.conf ${CMAKE_INSTALL_SYSCONFDIR}/icinga2/conf.d)
endif()

install_if_not_exists(icinga2/conf.d/notifications.conf ${CMAKE_INSTALL_SYSCONFDIR}/icinga2/conf.d)
install_if_not_exists(icinga2/conf.d/satellite.conf ${CMAKE_INSTALL_SYSCONFDIR}/icinga2/conf.d)
install_if_not_exists(icinga2/conf.d/templates.conf ${CMAKE_INSTALL_SYSCONFDIR}/icinga2/conf.d)
install_if_not_exists(icinga2/conf.d/timeperiods.conf ${CMAKE_INSTALL_SYSCONFDIR}/icinga2/conf.d)
install_if_not_exists(icinga2/conf.d/users.conf ${CMAKE_INSTALL_SYSCONFDIR}/icinga2/conf.d)
install_if_not_exists(icinga2/features-available/api.conf ${CMAKE_INSTALL_SYSCONFDIR}/icinga2/features-available)
install_if_not_exists(icinga2/features-available/debuglog.conf ${CMAKE_INSTALL_SYSCONFDIR}/icinga2/features-available)
install_if_not_exists(icinga2/features-available/icingastatus.conf ${CMAKE_INSTALL_SYSCONFDIR}/icinga2/features-available)
install_if_not_exists(icinga2/features-available/mainlog.conf ${CMAKE_INSTALL_SYSCONFDIR}/icinga2/features-available)
if(NOT WIN32)
  install_if_not_exists(icinga2/features-available/syslog.conf ${CMAKE_INSTALL_SYSCONFDIR}/icinga2/features-available)
endif()
install_if_not_exists(icinga2/scripts/mail-host-notification.sh ${CMAKE_INSTALL_SYSCONFDIR}/icinga2/scripts)
install_if_not_exists(icinga2/scripts/mail-service-notification.sh ${CMAKE_INSTALL_SYSCONFDIR}/icinga2/scripts)
install_if_not_exists(icinga2/zones.d/README ${CMAKE_INSTALL_SYSCONFDIR}/icinga2/zones.d)
install_if_not_exists(icinga2/repository.d/README ${CMAKE_INSTALL_SYSCONFDIR}/icinga2/repository.d)

if(${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
  install_if_not_exists(${CMAKE_CURRENT_BINARY_DIR}/logrotate.d/icinga2 ${CMAKE_INSTALL_SYSCONFDIR}/logrotate.d)
endif()

install(CODE "file(MAKE_DIRECTORY \"\$ENV{DESTDIR}${CMAKE_INSTALL_FULL_SYSCONFDIR}/icinga2/pki\")")
install(CODE "file(MAKE_DIRECTORY \"\$ENV{DESTDIR}${CMAKE_INSTALL_FULL_SYSCONFDIR}/icinga2/repository.d\")")

if(NOT WIN32)
  install(CODE "file(MAKE_DIRECTORY \"\$ENV{DESTDIR}${CMAKE_INSTALL_FULL_SYSCONFDIR}/icinga2/features-enabled\")")
  install(CODE "execute_process(COMMAND \"${CMAKE_COMMAND}\" -E create_symlink ../features-available/mainlog.conf \"\$ENV{DESTDIR}${CMAKE_INSTALL_FULL_SYSCONFDIR}/icinga2/features-enabled/mainlog.conf\")")

  install(
    FILES bash_completion.d/icinga2
    DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}/bash_completion.d
  )
else()
  install_if_not_exists(icinga2/features-enabled/mainlog.conf ${CMAKE_INSTALL_SYSCONFDIR}/icinga2/features-enabled)
endif()

if(${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
  add_subdirectory(initsystem)
endif()

set(CPACK_NSIS_EXTRA_INSTALL_COMMANDS "${CPACK_NSIS_EXTRA_INSTALL_COMMANDS}" PARENT_SCOPE)

=== icinga-studio/CMakeLists.txt ===
# Icinga 2
# Copyright (C) 2012-2016 Icinga Development Team (https://www.icinga.org/)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation
# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.

set(wxWidgets_CONFIGURATION mswu)
find_package(wxWidgets COMPONENTS core base propgrid adv REQUIRED)
include(${wxWidgets_USE_FILE})

if(MSVC)
  set(WindowsSources icinga.rc)
else()
  set(WindowsSources "")
endif()

add_executable(icinga-studio MACOSX_BUNDLE WIN32 icinga-studio.cpp
  forms.cpp aboutform.cpp connectform.cpp mainform.cpp
  icinga.icns ${WindowsSources})

include_directories(${Boost_INCLUDE_DIRS})
target_link_libraries(icinga-studio ${Boost_LIBRARIES} ${wxWidgets_LIBRARIES} base remote)

if(APPLE)
  set_source_files_properties(icinga.icns PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
endif()

set_target_properties (
  icinga-studio PROPERTIES
  INSTALL_RPATH ${CMAKE_INSTALL_FULL_LIBDIR}/icinga2
  FOLDER Bin
  OUTPUT_NAME icinga-studio
  MACOSX_BUNDLE_INFO_STRING "Icinga Studio"
  MACOSX_BUNDLE_BUNDLE_NAME "Icinga Studio"
  MACOSX_BUNDLE_GUI_IDENTIFIER "Icinga Studio"
  MACOSX_BUNDLE_ICON_FILE icinga.icns
  MACOSX_BUNDLE_SHORT_VERSION_STRING "${GIT_VERSION}"
  MACOSX_BUNDLE_LONG_VERSION_STRING "${GIT_VERSION}"
  MACOSX_BUNDLE_COPYRIGHT "(c) Icinga Development Team"
  MACOSX_BUNDLE_INFO_PLIST "${CMAKE_CURRENT_SOURCE_DIR}/MacOSXBundleInfo.plist.in"
)

if(WIN32)
  set(InstallPath "${CMAKE_INSTALL_SBINDIR}")
else()
  set(InstallPath "${CMAKE_INSTALL_BINDIR}")
endif()

install(
  TARGETS icinga-studio
  RUNTIME DESTINATION ${InstallPath}
  BUNDLE DESTINATION ${InstallPath}
)

=== itl/CMakeLists.txt ===
# Icinga 2
# Copyright (C) 2012-2016 Icinga Development Team (https://www.icinga.org/)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation
# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.

add_subdirectory(plugins-contrib.d)

install(
  FILES itl command.conf command-icinga.conf hangman timeperiod.conf plugins command-plugins.conf manubulon command-plugins-manubulon.conf windows-plugins command-plugins-windows.conf nscp command-nscp-local.conf plugins-contrib
  DESTINATION ${CMAKE_INSTALL_DATADIR}/icinga2/include
)

=== test/CMakeLists.txt ===
# Icinga 2
# Copyright (C) 2012-2016 Icinga Development Team (https://www.icinga.org/)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation
# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.

include(BoostTestTargets)

set(base_test_SOURCES
  base-array.cpp base-convert.cpp base-dictionary.cpp base-fifo.cpp
  base-json.cpp base-match.cpp base-netstring.cpp base-object.cpp
  base-serialize.cpp base-shellescape.cpp base-stacktrace.cpp
  base-stream.cpp base-string.cpp base-timer.cpp base-type.cpp
  base-value.cpp config-ops.cpp icinga-macros.cpp
  icinga-perfdata.cpp test.cpp 
  remote-base64.cpp remote-url.cpp
)

set(livestatus_test_SOURCES
  livestatus.cpp
  test.cpp
)

set_property(SOURCE test.cpp PROPERTY EXCLUDE_UNITY_BUILD TRUE)

if(ICINGA2_UNITY_BUILD)
    mkunity_target(test base_test_SOURCES)
endif()

add_boost_test(base
  SOURCES test.cpp ${base_test_SOURCES}
  LIBRARIES base config icinga
  TESTS base_array/construct
        base_array/getset
        base_array/resize
        base_array/insert
        base_array/remove
        base_array/foreach
        base_array/clone
        base_array/json
        base_convert/tolong
        base_convert/todouble
        base_convert/tostring
        base_convert/tobool
        base_dictionary/construct
        base_dictionary/get1
        base_dictionary/get2
        base_dictionary/foreach
        base_dictionary/remove
        base_dictionary/clone
        base_dictionary/json
        base_fifo/construct
        base_fifo/io
        base_json/invalid1
        base_match/tolong
        base_netstring/netstring
        base_object/construct
        base_object/getself
        base_serialize/scalar
        base_serialize/array
        base_serialize/dictionary
        base_serialize/object
        base_shellescape/escape_basic
        base_shellescape/escape_quoted
        base_stacktrace/stacktrace
        base_stream/readline_stdio
        base_string/construct
        base_string/equal
        base_string/clear
        base_string/append
        base_string/trim
        base_string/contains
        base_string/replace
        base_string/index
        base_string/find
        base_timer/construct
        base_timer/interval
        base_timer/invoke
        base_timer/scope
        base_type/gettype
        base_type/assign
        base_type/byname
        base_type/instantiate
        base_value/scalar
        base_value/convert
        base_value/format
        config_ops/simple
        config_ops/advanced
        icinga_macros/simple
        icinga_perfdata/empty
        icinga_perfdata/simple
        icinga_perfdata/quotes
        icinga_perfdata/multiple
        icinga_perfdata/uom
        icinga_perfdata/warncritminmax
        icinga_perfdata/ignore_invalid_warn_crit_min_max
        icinga_perfdata/invalid
        icinga_perfdata/multi
        remote_base64/base64
        remote_url/id_and_path
        remote_url/parameters
        remote_url/get_and_set
        remote_url/format
        remote_url/illegal_legal_strings
)

if(ICINGA2_WITH_LIVESTATUS)
  add_boost_test(livestatus
    SOURCES test.cpp ${livestatus_test_SOURCES}
    LIBRARIES base config icinga cli livestatus
    TESTS livestatus/hosts livestatus/services
  )
endif()

=== itl/plugins-contrib.d/CMakeLists.txt ===
# Icinga 2
# Copyright (C) 2012-2016 Icinga Development Team (https://www.icinga.org/)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation
# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.

install(
  FILES databases.conf icingacli.conf ipmi.conf network-components.conf operating-system.conf virtualization.conf vmware.conf web.conf hardware.conf
  DESTINATION ${CMAKE_INSTALL_DATADIR}/icinga2/include/plugins-contrib.d
)

=== lib/base/CMakeLists.txt ===
# Icinga 2
# Copyright (C) 2012-2016 Icinga Development Team (https://www.icinga.org/)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation
# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.

mkclass_target(application.ti application.tcpp application.thpp)
mkclass_target(configobject.ti configobject.tcpp configobject.thpp)
mkclass_target(filelogger.ti filelogger.tcpp filelogger.thpp)
mkclass_target(logger.ti logger.tcpp logger.thpp)
mkclass_target(streamlogger.ti streamlogger.tcpp streamlogger.thpp)
mkclass_target(sysloglogger.ti sysloglogger.tcpp sysloglogger.thpp)

set(base_SOURCES
  application.cpp application.thpp application-version.cpp array.cpp
  array-script.cpp boolean.cpp boolean-script.cpp console.cpp context.cpp
  convert.cpp debuginfo.cpp dictionary.cpp dictionary-script.cpp
  configobject.cpp configobject.thpp configobject-script.cpp configtype.cpp configwriter.cpp dependencygraph.cpp
  exception.cpp fifo.cpp filelogger.cpp filelogger.thpp initialize.cpp json.cpp
  json-script.cpp loader.cpp logger.cpp logger.thpp math-script.cpp
  netstring.cpp networkstream.cpp number.cpp number-script.cpp object.cpp
  object-script.cpp objecttype.cpp primitivetype.cpp process.cpp ringbuffer.cpp scriptframe.cpp
  function.cpp function-script.cpp functionwrapper.cpp scriptglobal.cpp
  scriptutils.cpp serializer.cpp socket.cpp socketevents.cpp socketevents-epoll.cpp socketevents-poll.cpp stacktrace.cpp
  statsfunction.cpp stdiostream.cpp stream.cpp streamlogger.cpp streamlogger.thpp string.cpp string-script.cpp
  sysloglogger.cpp sysloglogger.thpp tcpsocket.cpp threadpool.cpp timer.cpp
  tlsstream.cpp tlsutility.cpp type.cpp typetype-script.cpp unixsocket.cpp utility.cpp value.cpp
  value-operators.cpp workqueue.cpp
)

set_property(SOURCE ${CMAKE_CURRENT_SOURCE_DIR}/application-version.cpp PROPERTY EXCLUDE_UNITY_BUILD TRUE)

if(ICINGA2_UNITY_BUILD)
    mkunity_target(base base_SOURCES)
endif()

add_library(base SHARED ${base_SOURCES})

target_link_libraries(base ${CMAKE_DL_LIBS} ${Boost_LIBRARIES} ${OPENSSL_LIBRARIES} ${YAJL_LIBRARIES} mmatch socketpair)

if(HAVE_LIBEXECINFO)
    target_link_libraries(base execinfo)
endif()

include_directories(${icinga2_SOURCE_DIR}/third-party/execvpe)
link_directories(${icinga2_BINARY_DIR}/third-party/execvpe)

include_directories(${icinga2_SOURCE_DIR}/third-party/mmatch)
link_directories(${icinga2_BINARY_DIR}/third-party/mmatch)

include_directories(${icinga2_SOURCE_DIR}/third-party/socketpair)
link_directories(${icinga2_BINARY_DIR}/third-party/socketpair)

if(UNIX OR CYGWIN)
  target_link_libraries(base execvpe)
endif()

if(WIN32)
  target_link_libraries(base ws2_32 dbghelp shlwapi msi)
endif()

set_target_properties (
  base PROPERTIES
  INSTALL_RPATH ${CMAKE_INSTALL_FULL_LIBDIR}/icinga2
  DEFINE_SYMBOL I2_BASE_BUILD
  FOLDER Lib
)

install(CODE "file(MAKE_DIRECTORY \"\$ENV{DESTDIR}${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/cache/icinga2\")")
install(CODE "file(MAKE_DIRECTORY \"\$ENV{DESTDIR}${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/log/icinga2/crash\")")

install(
  TARGETS base
  RUNTIME DESTINATION ${CMAKE_INSTALL_SBINDIR}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}/icinga2
)

if(APPLE)
  install(
    TARGETS base
    LIBRARY DESTINATION ${CMAKE_INSTALL_BINDIR}/icinga-studio.app/Contents
  )
endif()

set(CPACK_NSIS_EXTRA_INSTALL_COMMANDS "${CPACK_NSIS_EXTRA_INSTALL_COMMANDS}" PARENT_SCOPE)

=== lib/checker/CMakeLists.txt ===
# Icinga 2
# Copyright (C) 2012-2016 Icinga Development Team (https://www.icinga.org/)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation
# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.

mkclass_target(checkercomponent.ti checkercomponent.tcpp checkercomponent.thpp)

set(checker_SOURCES
  checkercomponent.cpp checkercomponent.thpp
)

if(ICINGA2_UNITY_BUILD)
    mkunity_target(checker checker_SOURCES)
endif()

add_library(checker SHARED ${checker_SOURCES})

target_link_libraries(checker ${Boost_LIBRARIES} base config icinga remote)

set_target_properties (
  checker PROPERTIES
  INSTALL_RPATH ${CMAKE_INSTALL_FULL_LIBDIR}/icinga2
  DEFINE_SYMBOL I2_CHECKER_BUILD
  FOLDER Components
)

install_if_not_exists(
  ${PROJECT_SOURCE_DIR}/etc/icinga2/features-available/checker.conf
  ${CMAKE_INSTALL_SYSCONFDIR}/icinga2/features-available
)

if(NOT WIN32)
  install(CODE "file(MAKE_DIRECTORY \"\$ENV{DESTDIR}${CMAKE_INSTALL_FULL_SYSCONFDIR}/icinga2/features-enabled\")")
  install(CODE "execute_process(COMMAND \"${CMAKE_COMMAND}\" -E create_symlink ../features-available/checker.conf \"\$ENV{DESTDIR}${CMAKE_INSTALL_FULL_SYSCONFDIR}/icinga2/features-enabled/checker.conf\")")
else()
  install_if_not_exists(${PROJECT_SOURCE_DIR}/etc/icinga2/features-enabled/checker.conf ${CMAKE_INSTALL_SYSCONFDIR}/icinga2/features-enabled)
endif()

install(
  TARGETS checker
  RUNTIME DESTINATION ${CMAKE_INSTALL_SBINDIR}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}/icinga2
)

set(CPACK_NSIS_EXTRA_INSTALL_COMMANDS "${CPACK_NSIS_EXTRA_INSTALL_COMMANDS}" PARENT_SCOPE)

=== lib/cli/CMakeLists.txt ===
# Icinga 2
# Copyright (C) 2012-2016 Icinga Development Team (https://www.icinga.org/)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation
# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.

set(cli_SOURCES
  apisetupcommand.cpp apisetuputility.cpp
  nodeaddcommand.cpp nodeblackandwhitelistcommand.cpp nodelistcommand.cpp noderemovecommand.cpp
  nodesetcommand.cpp nodesetupcommand.cpp nodeupdateconfigcommand.cpp nodewizardcommand.cpp nodeutility.cpp
  clicommand.cpp
  consolecommand.cpp
  daemoncommand.cpp daemonutility.cpp
  featureenablecommand.cpp featuredisablecommand.cpp featurelistcommand.cpp featureutility.cpp
  objectlistcommand.cpp objectlistutility.cpp
  pkinewcacommand.cpp pkinewcertcommand.cpp pkisigncsrcommand.cpp pkirequestcommand.cpp pkisavecertcommand.cpp pkiticketcommand.cpp
  pkiutility.cpp
  repositoryclearchangescommand.cpp repositorycommitcommand.cpp repositoryobjectcommand.cpp repositoryutility.cpp
  variablegetcommand.cpp variablelistcommand.cpp variableutility.cpp
  troubleshootcommand.cpp
)

if(ICINGA2_UNITY_BUILD)
    mkunity_target(cli cli_SOURCES)
endif()

add_library(cli SHARED ${cli_SOURCES})

target_link_libraries(cli ${Boost_LIBRARIES} base config remote)

if(EDITLINE_FOUND)
  target_link_libraries(cli ${EDITLINE_LIBRARIES})
  include_directories(${EDITLINE_INCLUDE_DIR})
endif()

if(TERMCAP_FOUND)
  target_link_libraries(cli ${TERMCAP_LIBRARIES})
  include_directories(${TERMCAP_INCLUDE_DIR})
endif()

set_target_properties (
  cli PROPERTIES
  INSTALL_RPATH ${CMAKE_INSTALL_FULL_LIBDIR}/icinga2
  DEFINE_SYMBOL I2_CLI_BUILD
  FOLDER Lib
)

install(
  TARGETS cli
  RUNTIME DESTINATION ${CMAKE_INSTALL_SBINDIR}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}/icinga2
)

=== lib/compat/CMakeLists.txt ===
# Icinga 2
# Copyright (C) 2012-2016 Icinga Development Team (https://www.icinga.org/)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation
# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.

mkclass_target(checkresultreader.ti checkresultreader.tcpp checkresultreader.thpp)
mkclass_target(compatlogger.ti compatlogger.tcpp compatlogger.thpp)
mkclass_target(externalcommandlistener.ti externalcommandlistener.tcpp externalcommandlistener.thpp)
mkclass_target(statusdatawriter.ti statusdatawriter.tcpp statusdatawriter.thpp)

set(compat_SOURCES
  checkresultreader.cpp checkresultreader.thpp compatlogger.cpp
  compatlogger.thpp externalcommandlistener.cpp externalcommandlistener.thpp
  statusdatawriter.cpp statusdatawriter.thpp
)

if(ICINGA2_UNITY_BUILD)
    mkunity_target(compat compat_SOURCES)
endif()

add_library(compat SHARED ${compat_SOURCES})

target_link_libraries(compat ${Boost_LIBRARIES} base config icinga)

set_target_properties (
  compat PROPERTIES
  INSTALL_RPATH ${CMAKE_INSTALL_FULL_LIBDIR}/icinga2
  DEFINE_SYMBOL I2_COMPAT_BUILD
  FOLDER Components
)

install_if_not_exists(
  ${PROJECT_SOURCE_DIR}/etc/icinga2/features-available/command.conf
  ${CMAKE_INSTALL_SYSCONFDIR}/icinga2/features-available
)

install_if_not_exists(
  ${PROJECT_SOURCE_DIR}/etc/icinga2/features-available/compatlog.conf
  ${CMAKE_INSTALL_SYSCONFDIR}/icinga2/features-available
)

install_if_not_exists(
  ${PROJECT_SOURCE_DIR}/etc/icinga2/features-available/statusdata.conf
  ${CMAKE_INSTALL_SYSCONFDIR}/icinga2/features-available
)

install(TARGETS compat RUNTIME DESTINATION ${CMAKE_INSTALL_SBINDIR} LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}/icinga2)

install(CODE "file(MAKE_DIRECTORY \"\$ENV{DESTDIR}${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/log/icinga2/compat/archives\")")
install(CODE "file(MAKE_DIRECTORY \"\$ENV{DESTDIR}${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/spool/icinga2\")")
install(CODE "file(MAKE_DIRECTORY \"\$ENV{DESTDIR}${ICINGA2_RUNDIR}/icinga2/cmd\")")

set(CPACK_NSIS_EXTRA_INSTALL_COMMANDS "${CPACK_NSIS_EXTRA_INSTALL_COMMANDS}" PARENT_SCOPE)

=== lib/config/CMakeLists.txt ===
# Icinga 2
# Copyright (C) 2012-2016 Icinga Development Team (https://www.icinga.org/)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation
# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.

find_package(BISON 2.3.0 REQUIRED)
find_package(FLEX 2.5.31 REQUIRED)

bison_target(config_parser config_parser.yy ${CMAKE_CURRENT_BINARY_DIR}/config_parser.cc)
set_property(SOURCE ${CMAKE_CURRENT_BINARY_DIR}/config_parser.cc PROPERTY EXCLUDE_UNITY_BUILD TRUE)

flex_target(config_lexer config_lexer.ll ${CMAKE_CURRENT_BINARY_DIR}/config_lexer.cc)
set_property(SOURCE ${CMAKE_CURRENT_BINARY_DIR}/config_lexer.cc PROPERTY EXCLUDE_UNITY_BUILD TRUE)

if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  set_property(SOURCE ${CMAKE_CURRENT_BINARY_DIR}/config_parser.cc PROPERTY COMPILE_FLAGS "-Wno-deprecated-register")
  set_property(SOURCE ${CMAKE_CURRENT_BINARY_DIR}/config_lexer.cc PROPERTY COMPILE_FLAGS "-Wno-deprecated-register")
endif()

add_flex_bison_dependency(config_lexer config_parser)

include_directories(${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR})

set(config_SOURCES
  activationcontext.cpp applyrule.cpp
  configcompilercontext.cpp configcompiler.cpp configitembuilder.cpp
  configitem.cpp ${FLEX_config_lexer_OUTPUTS} ${BISON_config_parser_OUTPUTS}
  expression.cpp objectrule.cpp
)

if(ICINGA2_UNITY_BUILD)
    mkunity_target(config config_SOURCES)
endif()

add_library(config SHARED ${config_SOURCES})

target_link_libraries(config ${Boost_LIBRARIES} base) 

set_target_properties (
  config PROPERTIES
  INSTALL_RPATH ${CMAKE_INSTALL_FULL_LIBDIR}/icinga2
  DEFINE_SYMBOL I2_CONFIG_BUILD
  FOLDER Lib
)

install(
  TARGETS config
  RUNTIME DESTINATION ${CMAKE_INSTALL_SBINDIR}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}/icinga2
)

if(APPLE)
  install(
    TARGETS config
    LIBRARY DESTINATION ${CMAKE_INSTALL_BINDIR}/icinga-studio.app/Contents
  )
endif()

=== lib/db_ido/CMakeLists.txt ===
# Icinga 2
# Copyright (C) 2012-2016 Icinga Development Team (https://www.icinga.org/)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation
# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.

mkclass_target(dbconnection.ti dbconnection.tcpp dbconnection.thpp)

mkembedconfig_target(db_ido-itl.conf db_ido-itl.cpp)

set(db_ido_SOURCES
  commanddbobject.cpp dbconnection.cpp dbconnection.thpp
  db_ido-itl.cpp dbevents.cpp dbobject.cpp dbquery.cpp
  dbreference.cpp dbtype.cpp dbvalue.cpp endpointdbobject.cpp hostdbobject.cpp
  hostgroupdbobject.cpp idochecktask.cpp servicedbobject.cpp
  servicegroupdbobject.cpp timeperioddbobject.cpp userdbobject.cpp
  usergroupdbobject.cpp zonedbobject.cpp
)

if(ICINGA2_UNITY_BUILD)
    mkunity_target(db_ido db_ido_SOURCES)
endif()

add_library(db_ido SHARED ${db_ido_SOURCES})

include_directories(${Boost_INCLUDE_DIRS})
target_link_libraries(db_ido ${Boost_LIBRARIES} base config icinga remote)

set_target_properties (
  db_ido PROPERTIES
  INSTALL_RPATH ${CMAKE_INSTALL_FULL_LIBDIR}/icinga2
  DEFINE_SYMBOL I2_DB_IDO_BUILD
  FOLDER Lib
)

install(
  TARGETS db_ido
  RUNTIME DESTINATION ${CMAKE_INSTALL_SBINDIR}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}/icinga2
)

=== debian/changelog ===
icinga2 (2.4.10-1) unstable; urgency=medium

  * [c5525bc] Imported Upstream version 2.4.10

 -- Alexander Wirt <formorer@debian.org>  Thu, 19 May 2016 13:41:17 +0200

icinga2 (2.4.9-1) unstable; urgency=medium

  * [71d8006] Imported Upstream version 2.4.9

 -- Alexander Wirt <formorer@debian.org>  Thu, 19 May 2016 11:30:53 +0200

icinga2 (2.4.8-1) unstable; urgency=medium

  * [c734d9e] Imported Upstream version 2.4.8

 -- Alexander Wirt <alexander.wirt@credativ.de>  Tue, 17 May 2016 13:23:10 +0200

icinga2 (2.4.7-1) unstable; urgency=medium

  * Imported Upstream version 2.4.7

 -- Alexander Wirt <formorer@debian.org>  Thu, 21 Apr 2016 18:35:07 +0200

icinga2 (2.4.6-1) unstable; urgency=medium

  * Imported Upstream version 2.4.6

 -- Alexander Wirt <formorer@debian.org>  Wed, 20 Apr 2016 18:57:22 +0200

icinga2 (2.4.5-1) unstable; urgency=medium

  * [26a7374] Imported Upstream version 2.4.5

 -- Alexander Wirt <formorer@debian.org>  Wed, 20 Apr 2016 13:09:03 +0200

icinga2 (2.4.4-1) unstable; urgency=medium

  * [a2d01fb] Imported Upstream version 2.4.4

 -- Alexander Wirt <formorer@debian.org>  Wed, 16 Mar 2016 12:10:49 +0100

icinga2 (2.4.3-1) unstable; urgency=medium

  * [39ba8d6] Imported Upstream version 2.4.3

 -- Markus Frosch <lazyfrosch@debian.org>  Wed, 24 Feb 2016 16:13:18 +0100

icinga2 (2.4.2-1) unstable; urgency=medium

  * [3584c36] Imported Upstream version 2.4.2
  * [89ee45e] Bump standards version to 3.9.7

 -- Markus Frosch <lazyfrosch@debian.org>  Tue, 23 Feb 2016 16:30:32 +0100

=== debian/control ===
Source: icinga2
Section: admin
Priority: extra
Maintainer: Debian Nagios Maintainer Group <pkg-nagios-devel@lists.alioth.debian.org>
Uploaders: Markus Frosch <lazyfrosch@debian.org>,
           Jan Wagner <waja@cyconet.org>,
           Alexander Wirt <formorer@debian.org>
Build-Depends: bash-completion,
               bison,
               cmake (>= 2.8.7),
               debhelper (>= 9),
               dh-systemd (>= 1.5),
               flex,
               g++ (>= 1.96),
               libboost-dev,
               libboost-program-options-dev,
               libboost-regex-dev,
               libboost-system-dev,
               libboost-test-dev,
               libboost-thread-dev,
               libmysqlclient-dev,
               libpq-dev,
               libssl-dev,
               libyajl-dev,
               libedit-dev,
               libwxgtk3.0-dev,
               make (>= 3.81),
               po-debconf
Standards-Version: 3.9.7
Homepage: http://www.icinga.org
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-nagios/pkg-icinga2.git
Vcs-Git: https://anonscm.debian.org/git/pkg-nagios/pkg-icinga2.git

Package: icinga2
Architecture: any
Depends: icinga2-bin (= ${binary:Version}),
         icinga2-common (= ${source:Version}),
         ${misc:Depends}
Recommends: icinga2-doc, monitoring-plugins-basic | nagios-plugins-basic, libreadline6
Suggests: icinga2-studio, vim-icinga2
Description: host and network monitoring system
 Icinga 2 is a general-purpose monitoring application to fit the needs of
 any size of network. Icinga 1.x was a Nagios fork; this new generation
 has been rewritten from scratch in C++, with multi-threading and cluster
 support.
 .
 Features:
  * all standard features of Icinga and Nagios;
  * much faster and more scalable than Icinga 1 and Nagios;
  * new, more intuitive, template-based configuration format;
  * monitoring services on ICMP (ping) or TCP ports (HTTP, NNTP, POP3,
    SMTP, etc.) by executing checks (see monitoring-plugins*);
  * any small script following the Nagios plugin API can be used as a
    check plugin;
  * notifications about alerts for any custom script (with examples);
  * native support for Livestatus and Graphite.
 .
 This is the metapackage to install all Icinga 2 features.

Package: icinga2-common
Architecture: all
Replaces: python-icinga2
Conflicts: python-icinga2
Provides: python-icinga2
Depends:
    adduser,
    lsb-release,
    ${misc:Depends}
Recommends: logrotate
Description: host and network monitoring system - common files
 Icinga 2 is a general-purpose monitoring application to fit the needs of
 any size of network. Icinga 1.x was a Nagios fork; this new generation
 has been rewritten from scratch in C++, with multi-threading and cluster
 support.
 .
 Features:
  * all standard features of Icinga and Nagios;
  * much faster and more scalable than Icinga 1 and Nagios;
  * new, more intuitive, template-based configuration format;
  * monitoring services on ICMP (ping) or TCP ports (HTTP, NNTP, POP3,
    SMTP, etc.) by executing checks (see monitoring-plugins*);
  * any small script following the Nagios plugin API can be used as a
    check plugin;
  * notifications about alerts for any custom script (with examples);
  * native support for Livestatus and Graphite.
 .
 This package provides configuration and some basic helper scripts.

Package: icinga2-bin
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: icinga2-common (= ${source:Version}),
         libicinga2 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: host and network monitoring system - daemon
 Icinga 2 is a general-purpose monitoring application to fit the needs of
 any size of network. Icinga 1.x was a Nagios fork; this new generation
 has been rewritten from scratch in C++, with multi-threading and cluster
 support.
 .
 Features:
  * all standard features of Icinga and Nagios;
  * much faster and more scalable than Icinga 1 and Nagios;
  * new, more intuitive, template-based configuration format;
  * monitoring services on ICMP (ping) or TCP ports (HTTP, NNTP, POP3,
    SMTP, etc.) by executing checks (see monitoring-plugins*);
  * any small script following the Nagios plugin API can be used as a
    check plugin;
  * notifications about alerts for any custom script (with examples);
  * native support for Livestatus and Graphite.
 .
 This package provides the Icinga 2 daemon.

Package: icinga2-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: host and network monitoring system - documentation
 Icinga 2 is a general-purpose monitoring application to fit the needs of
 any size of network. Icinga 1.x was a Nagios fork; this new generation
 has been rewritten from scratch in C++, with multi-threading and cluster
 support.
 .
 Features:
  * all standard features of Icinga and Nagios;
  * much faster and more scalable than Icinga 1 and Nagios;
  * new, more intuitive, template-based configuration format;
  * monitoring services on ICMP (ping) or TCP ports (HTTP, NNTP, POP3,
    SMTP, etc.) by executing checks (see monitoring-plugins*);
  * any small script following the Nagios plugin API can be used as a
    check plugin;
  * notifications about alerts for any custom script (with examples);
  * native support for Livestatus and Graphite.
 .
 This package provides the Icinga 2 documentation.

Package: icinga2-classicui
Architecture: all
Pre-Depends: dpkg (>= 1.15.7.2)
Depends: apache2-utils,
         icinga-cgi-bin (>= 1.11.5~),
         icinga2-bin (>= 2.2.0~),
         icinga2-common (= ${source:Version}),
         ${misc:Depends}
Recommends: apache2 | httpd
Description: host and network monitoring system - classic UI
 Icinga 2 is a general-purpose monitoring application to fit the needs of
 any size of network. Icinga 1.x was a Nagios fork; this new generation
 has been rewritten from scratch in C++, with multi-threading and cluster
 support.
 .
 Features:
  * all standard features of Icinga and Nagios;
  * much faster and more scalable than Icinga 1 and Nagios;
  * new, more intuitive, template-based configuration format;
  * monitoring services on ICMP (ping) or TCP ports (HTTP, NNTP, POP3,
    SMTP, etc.) by executing checks (see monitoring-plugins*);
  * any small script following the Nagios plugin API can be used as a
    check plugin;
  * notifications about alerts for any custom script (with examples);
  * native support for Livestatus and Graphite.
 .
 This package provides support for the Icinga Classic User Interface.

Package: icinga2-ido-mysql
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Conflicts: icinga2-ido-pgsql
Depends: dbconfig-common,
         icinga2-bin (= ${binary:Version}),
         icinga2-common (= ${source:Version}),
         ucf,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: mysql-client | virtual-mysql-client
Suggests: mysql-server
Description: host and network monitoring system - MySQL support
 Icinga 2 is a general-purpose monitoring application to fit the needs of
 any size of network. Icinga 1.x was a Nagios fork; this new generation
 has been rewritten from scratch in C++, with multi-threading and cluster
 support.
 .
 Features:
  * all standard features of Icinga and Nagios;
  * much faster and more scalable than Icinga 1 and Nagios;
  * new, more intuitive, template-based configuration format;
  * monitoring services on ICMP (ping) or TCP ports (HTTP, NNTP, POP3,
    SMTP, etc.) by executing checks (see monitoring-plugins*);
  * any small script following the Nagios plugin API can be used as a
    check plugin;
  * notifications about alerts for any custom script (with examples);
  * native support for Livestatus and Graphite.
 .
 This package provides the IDO module for the MySQL database.

Package: icinga2-ido-pgsql
Architecture: any
Conflicts: icinga2-ido-mysql
Pre-Depends: ${misc:Pre-Depends}
Depends: dbconfig-common,
         icinga2-bin (= ${binary:Version}),
         icinga2-common (= ${source:Version}),
         ucf,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: postgresql-client
Suggests: postgresql
Description: host and network monitoring system - PostgreSQL support
 Icinga 2 is a general-purpose monitoring application to fit the needs of
 any size of network. Icinga 1.x was a Nagios fork; this new generation
 has been rewritten from scratch in C++, with multi-threading and cluster
 support.
 .
 Features:
  * all standard features of Icinga and Nagios;
  * much faster and more scalable than Icinga 1 and Nagios;
  * new, more intuitive, template-based configuration format;
  * monitoring services on ICMP (ping) or TCP ports (HTTP, NNTP, POP3,
    SMTP, etc.) by executing checks (see monitoring-plugins*);
  * any small script following the Nagios plugin API can be used as a
    check plugin;
  * notifications about alerts for any custom script (with examples);
  * native support for Livestatus and Graphite.
 .
 This package provides the IDO module for the PostgreSQL database.

Package: icinga2-dbg
Architecture: any
Section: debug
Depends: icinga2-bin (= ${binary:Version}),
         libicinga2 (= ${binary:Version}),
         ${misc:Depends}
Description: host and network monitoring system - debug symbols
 Icinga 2 is a general-purpose monitoring application to fit the needs of
 any size of network. Icinga 1.x was a Nagios fork; this new generation
 has been rewritten from scratch in C++, with multi-threading and cluster
 support.
 .
 Features:
  * all standard features of Icinga and Nagios;
  * much faster and more scalable than Icinga 1 and Nagios;
  * new, more intuitive, template-based configuration format;
  * monitoring services on ICMP (ping) or TCP ports (HTTP, NNTP, POP3,
    SMTP, etc.) by executing checks (see monitoring-plugins*);
  * any small script following the Nagios plugin API can be used as a
    check plugin;
  * notifications about alerts for any custom script (with examples);
  * native support for Livestatus and Graphite.
 .
 This package provides debug symbols for Icinga 2.

Package: libicinga2
Architecture: any
Section: libs
Breaks: icinga2-bin (<< 2.4.0-1~)
Replaces: icinga2-bin (<< 2.4.0-1~)
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: host and network monitoring system - internal libraries
 Icinga 2 is a general-purpose monitoring application to fit the needs of
 any size of network. Icinga 1.x was a Nagios fork; this new generation
 has been rewritten from scratch in C++, with multi-threading and cluster
 support.
 .
 Features:
  * all standard features of Icinga and Nagios;
  * much faster and more scalable than Icinga 1 and Nagios;
  * new, more intuitive, template-based configuration format;
  * monitoring services on ICMP (ping) or TCP ports (HTTP, NNTP, POP3,
    SMTP, etc.) by executing checks (see monitoring-plugins*);
  * any small script following the Nagios plugin API can be used as a
    check plugin;
  * notifications about alerts for any custom script (with examples);
  * native support for Livestatus and Graphite.
 .
 This package provides internal libraries for the daemon or studio.

Package: icinga2-studio
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: libicinga2 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: host and network monitoring system - studio API GUI
 Icinga 2 is a general-purpose monitoring application to fit the needs of
 any size of network. Icinga 1.x was a Nagios fork; this new generation
 has been rewritten from scratch in C++, with multi-threading and cluster
 support.
 .
 Features:
  * all standard features of Icinga and Nagios;
  * much faster and more scalable than Icinga 1 and Nagios;
  * new, more intuitive, template-based configuration format;
  * monitoring services on ICMP (ping) or TCP ports (HTTP, NNTP, POP3,
    SMTP, etc.) by executing checks (see monitoring-plugins*);
  * any small script following the Nagios plugin API can be used as a

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

%:
	dh $@ --with systemd --with bash_completion

override_dh_systemd_enable:
	dh_systemd_enable --name=icinga2
override_dh_auto_build:
	dh_auto_build --parallel

override_dh_auto_clean:
	dh_auto_clean
	test ! -f third-party/cmake/GNUInstallDirs.cmake.disabled || \
		mv third-party/cmake/GNUInstallDirs.cmake.disabled third-party/cmake/GNUInstallDirs.cmake

override_dh_auto_configure:
	test -f third-party/cmake/GNUInstallDirs.cmake.disabled || \
		mv third-party/cmake/GNUInstallDirs.cmake third-party/cmake/GNUInstallDirs.cmake.disabled
	dh_auto_configure \
		-- \
		-DCMAKE_INSTALL_LOCALSTATEDIR=/var \
		-DCMAKE_INSTALL_SYSCONFDIR=/etc \
		-DICINGA2_RUNDIR=/run \
		-DICINGA2_USER=nagios \
		-DICINGA2_GROUP=nagios \
		-DICINGA2_COMMAND_GROUP=www-data \
		-DICINGA2_GIT_VERSION_INFO=false \
		-DICINGA2_PLUGINDIR=/usr/lib/nagios/plugins \
		-DICINGA2_WITH_STUDIO=true

override_dh_auto_install:
	dh_auto_install
	# remove features-enabled - these will be activated by postinst later
	rm -r debian/tmp/etc/icinga2/features-enabled/*

override_dh_install-indep:
	dh_install -i
	chmod +x debian/icinga2-common/usr/lib/icinga2/prepare-dirs
	rm debian/icinga2-common/etc/icinga2/features-available/ido-*

override_dh_install-arch:
	dh_install -a
	rm debian/libicinga2/usr/lib/*/icinga2/libdb_ido_*
	for dbms in mysql pgsql; do \
		mkdir -p debian/icinga2-ido-$$dbms/usr/share/dbconfig-common/data/icinga2-ido-$$dbms/install ; \
		mkdir -p debian/icinga2-ido-$$dbms/usr/share/dbconfig-common/data/icinga2-ido-$$dbms/upgrade/$$dbms; \
		cp lib/db_ido_$$dbms/schema/$$dbms.sql debian/icinga2-ido-$$dbms/usr/share/dbconfig-common/data/icinga2-ido-$$dbms/install/$$dbms ; \
		for file in lib/db_ido_$$dbms/schema/upgrade/* ; do \
			cp $$file debian/icinga2-ido-$$dbms/usr/share/dbconfig-common/data/icinga2-ido-$$dbms/upgrade/$$dbms/`basename $$file .sql`; \
		done; \
	done

override_dh_installinit:
	dh_installinit --name=icinga2

.PHONY: override_dh_strip
override_dh_strip:
	dh_strip --dbg-package=icinga2-dbg

# vi: noexpandtab ts=4 sw=4 :
